include \masm32\MasmBasic\MasmBasic.inc
if 0
	UsedTime = 7FFE0014h	; System time
	Magic=312588	; may differ
	Magic=312562	; according to
	Magic=312558	; the processor's mood
else
	UsedTime = 7FFE0008h	; Interrupt time
	Magic=312500	; always the same value
endif

KSYSTEM_TIME STRUCT
LowPart	dd ?
High1Time	dd ?		; UsedTime
High2Time	dd ?
KSYSTEM_TIME ENDS

Ticks2Stack MACRO
  mov edx, UsedTime	; aka [url=http://www.nirsoft.net/kernel_struct/vista/KUSER_SHARED_DATA.html]KUSER_SHARED_DATA.SystemTime.High1Time[/url]
; @@:
; mov eax, [edx]		; fails miserably, see...
; cmp eax, [edx+4]		; [url=http://www.dcl.hpi.uni-potsdam.de/research/WRK/2007/08/getting-os-information-the-kuser_shared_data-structure/]Windows Research Kernel @ HPI[/url]
; jne @B		; ... and look for consistent
  fild qword ptr [edx]
ENDM

TicksPop MACRO
	mov edx, UsedTime
	fild qword ptr [edx]
	fsub
	fchs
ENDM

	Init
	; invoke SetProcessAffinityMask, rv(GetCurrentProcess), 1
	PrintLine "Magic=", Hex$(Magic), CrLf$
	For_ n=0 To 10
		Ticks2Stack
		imul eax, n, 10
		push eax
		mov ecx, eax
		.Repeat
			mov edx, 1000000
			.Repeat
;			  mov eax, 123
			  imul eax, eax, 123
			  dec edx
			.Until Sign?
			dec ecx
		.Until Sign?
		TicksPop
		push Magic
		fidiv dword ptr [esp]	; divide ticks by magic number
		pop eax
		pop ecx
		Print Str$("Loop %i  \t", n), Str$("%Hf\n", ST(0))
		fstp st
	Next
	Exit
end start
OPT_Tmp2Asm	1
